local Grid2IndicatorButtonOptions = {}
Grid2Options.plugins["Grid2IndicatorButtonOptions"] = Grid2IndicatorButtonOptions

local L = LibStub("AceLocale-3.0"):GetLocale("Grid2Options")
local DBL = LibStub:GetLibrary("LibDBLayers-1.0")


-- dblData - data table for the mod
-- versions - table of version info
-- layers to create defaults for
function Grid2IndicatorButtonOptions:MakeDefaults(dblData, versions, layers)
	for i, layer in pairs(layers) do
		if (layer == "account") then
			if (versions.Grid2IndicatorButtonOptions < 1) then

				versions.Grid2IndicatorButtonOptions = 1
			end
		elseif (layer == "deathknight") then
			if (versions.deathknight.Grid2IndicatorButtonOptions < 1) then

				versions.deathknight.Grid2IndicatorButtonOptions = 1
			end
		elseif (layer == "druid") then
			if (versions.druid.Grid2IndicatorButtonOptions < 1) then
				DBL:SetupLayerObject(dblData, "indicators", layer, "rejuvenation", {
						type = "button",
						spellName = 774,
				})

				versions.druid.Grid2IndicatorButtonOptions = 1
			end
		elseif (layer == "hunter") then
			if (versions.hunter.Grid2IndicatorButtonOptions < 1) then

				versions.hunter.Grid2IndicatorButtonOptions = 1
			end
		elseif (layer == "mage") then
			if (versions.mage.Grid2IndicatorButtonOptions < 1) then

				versions.mage.Grid2IndicatorButtonOptions = 1
			end
		elseif (layer == "paladin") then
			if (versions.paladin.Grid2IndicatorButtonOptions < 1) then

				versions.paladin.Grid2IndicatorButtonOptions = 1
			end
		elseif (layer == "priest") then
			if (versions.priest.Grid2IndicatorButtonOptions < 1) then

				versions.priest.Grid2IndicatorButtonOptions = 1
			end
		elseif (layer == "rogue") then
			if (versions.rogue.Grid2IndicatorButtonOptions < 1) then

				versions.rogue.Grid2IndicatorButtonOptions = 1
			end
		elseif (layer == "shaman") then
			if (versions.shaman.Grid2IndicatorButtonOptions < 1) then

				versions.shaman.Grid2IndicatorButtonOptions = 1
			end
		elseif (layer == "warlock") then
			if (versions.warlock.Grid2IndicatorButtonOptions < 1) then

				versions.warlock.Grid2IndicatorButtonOptions = 1
			end
		elseif (layer == "warrior") then
			if (versions.warrior.Grid2IndicatorButtonOptions < 1) then

				versions.warrior.Grid2IndicatorButtonOptions = 1
			end
		end
	end
end

function Grid2IndicatorButtonOptions.UpgradeDefaults(dblData)
	local versionsSrc = dblData.versionsSrc
	local layerOrder = Grid2Options.layerOrder
	local layers = Grid2Options.layers
	
	DBL:InitializeObjectType(dblData, "alerts", layerOrder)
print("Grid2IndicatorButtonOptions UpgradeDefaults")

	Grid2IndicatorButtonOptions:MakeDefaults(dblData, versionsSrc, layers)
end



local function MakeButtonIndicatorOptions(indicator)
	local baseKey = indicator.name
	local options = {
		-- iconsize = {
			-- type = "range",
			-- order = 10,
			-- name = L["Icon Size"],
			-- desc = L["Adjust the size of the center icon."],
			-- min = 5,
			-- max = 50,
			-- step = 1,
			-- get = function ()
				-- return indicator.dbx.iconSize
			-- end,
			-- set = function (_, v)
				-- indicator.dbx.iconSize = v
				-- DBL:GetOptionsDbx(Grid2.dblData, "indicators", baseKey).iconSize = v	-- ToDo: handle nilling out if ancestor matches v
				-- Grid2Frame:WithAllFrames(function (f) indicator:SetIconSize(f, v) end)
			-- end,
		-- },
	}

	Grid2Options:MakeIndicatorTypeOptions(indicator, options)
	Grid2Options:AddIndicatorLocationOptions(indicator, options)
	Grid2Options:AddIndicatorLayerOptions(indicator, options)
	Grid2Options:MakeIndicatorColorOptions(indicator, options, {
			typeKey = "indicators",
	})
	Grid2Options:AddIndicatorStatusOptions(indicator, options)
	Grid2Options:AddIndicatorDeleteOptions(indicator, options)

	Grid2Options:AddIndicatorElement(indicator, options)
end

local prev_MakeIndicatorOptions = Grid2Options.MakeIndicatorOptions
function Grid2Options:MakeIndicatorOptions(dblData, reset, ...)
	self:AddCreatableOptionHandler("button", L["button"], MakeButtonIndicatorOptions)

	prev_MakeIndicatorOptions(self, dblData, reset, ...)
end

